// Copyright 2021 Varjo Technologies Oy. All rights reserved.

#ifndef VARJO_MOTION_PLATFORM_H
#define VARJO_MOTION_PLATFORM_H

#include "Varjo_export.h"
#include "Varjo_types.h"
#include "Varjo_plugin_common.h"

#if defined __cplusplus
extern "C" {
#endif  // __cplusplus

/**
 * @brief Requests tracked device pose update
 *
 * @param context - plugin session context acquired from @ref varjo_PluginInit
 * @param deviceType - device type for which the pose update is requested
 * @param pose - pointer to a structure containing the current device pose estimate
 * @param updatedPose - pointer to a structure receiving tracking pose
 * @return @ref varjo_PluginStatus_OK if the pose was updated successfully, other value of
 *         type @ref varjo_PluginStatus otherwise
 */
VARJO_API varjo_PluginStatus varjo_UpdatePose(  //
    varjo_PluginContext context,                //
    varjo_DeviceType deviceType,                //
    const varjo_DevicePose* pose,               //
    varjo_DevicePose* updatedPose);

#if defined __cplusplus
}  // extern "C"
#endif  // __cplusplus

#endif  // VARJO_MOTION_PLATFORM_H
